package de.moritzruth.dracula_musical.act

import de.moritzruth.dracula_musical.device.BlinderBars
import de.moritzruth.dracula_musical.device.StairvilleSplb
import de.moritzruth.theaterdsl.show.ShowBuilderContext
import de.moritzruth.theaterdsl.show.StepCue
import de.moritzruth.theaterdsl.value.percent

fun ShowBuilderContext.testingAct() = act("Testing") {
    scene("Testing") {
        lightStep(StepCue.Custom("null")) {
            BlinderBars.all {
                it.brightness.static(100.percent)
                it.effect.static(null)
                it.white.static(100.percent)
            }
        }

        lightStep(StepCue.Custom("StairvilleSplb.Effect.CHASE_BACK_AND_FORTH")) {
            BlinderBars.all {
                it.effect.static(StairvilleSplb.Effect.CHASE_BACK_AND_FORTH)
                it.effect.speed.static(20.percent)
            }
        }

        lightStep(StepCue.Custom("StairvilleSplb.Effect.BUMP_INWARDS")) {
            BlinderBars.all {
                it.effect.static(StairvilleSplb.Effect.BUMP_INWARDS)
                it.effect.speed.static(20.percent)
            }
        }

        lightStep(StepCue.Custom("StairvilleSplb.Effect.FLOW_OUTWARDS")) {
            BlinderBars.all {
                it.effect.static(StairvilleSplb.Effect.FLOW_OUTWARDS)
                it.effect.speed.static(50.percent)
            }
        }

        lightStep(StepCue.Custom("StairvilleSplb.Effect.FLOW_OUTWARDS_LONG")) {
            BlinderBars.all {
                it.effect.static(StairvilleSplb.Effect.FLOW_OUTWARDS_LONG)
                it.effect.speed.static(50.percent)
            }
        }

        lightStep(StepCue.Custom("StairvilleSplb.Effect.FLOW_INWARDS")) {
            BlinderBars.all {
                it.effect.static(StairvilleSplb.Effect.FLOW_INWARDS)
                it.effect.speed.static(50.percent)
            }
        }

        lightStep(StepCue.Custom("StairvilleSplb.Effect.FLOW_INWARDS_LONG")) {
            BlinderBars.all {
                it.effect.static(StairvilleSplb.Effect.FLOW_INWARDS_LONG)
                it.effect.speed.static(50.percent)
            }
        }

        lightStep(StepCue.Custom("StairvilleSplb.Effect.THEATRE_SWITCHING")) {
            BlinderBars.all {
                it.effect.static(StairvilleSplb.Effect.THEATRE_SWITCHING)
                it.effect.speed.static(20.percent)
            }
        }

        lightStep(StepCue.Custom("StairvilleSplb.Effect.HECTIC_SWITCHING")) {
            BlinderBars.all {
                it.effect.static(StairvilleSplb.Effect.HECTIC_SWITCHING)
                it.effect.speed.static(100.percent)
            }
        }
    }
}