package de.moritzruth.dracula_musical.song

import de.moritzruth.dracula_musical.device.*
import de.moritzruth.theaterdsl.show.SceneBuilderContext
import de.moritzruth.theaterdsl.show.StepCue
import de.moritzruth.theaterdsl.value.Color
import de.moritzruth.theaterdsl.value.percent
import kotlin.time.Duration.Companion.minutes
import kotlin.time.Duration.Companion.seconds

fun SceneBuilderContext.songRepriseMaskenball() {
    step(StepCue.MusicStart("Reprise: Maskenball", 1.minutes + 30.seconds)) {
        actors {
            // TODO: Expand
            +"Besucher des Maskenballs / durch Mitte"
            +"Kaffeetanten / durch Mitte"
            +"Lucy / im Off"  // TODO: which side?
        }

        onRun {
            FrontLights.all { it.brightness.fade(100.percent, 6.seconds) }

            Tops.both {
                it.startRoomMovement(5.0)
                it.colorWheelMode.static(FuturelightDmh160.ColorWheelMode.Rotate(10.percent))
                it.prismMode.static(FuturelightDmh160.PrismMode.FACETS_3)
                it.prismRotationSpeed.static(10.percent)
                it.brightness.fade(100.percent, 3.seconds)
            }

            Washs.both {
                it.pointAtCeiling()
                it.colorWheelMode.static(CoemarProWash.ColorWheelMode.Rotate(80.percent))
                it.brightness.fade(100.percent, 3.seconds)
            }

            backlightBar.color.cycle(8.seconds)
            backlightBar.brightness.fade(50.percent, 3.seconds)

            BlinderBars.all {
                it.effect.static(StairvilleSplb.Effect.THEATRE_SWITCHING)
                it.effect.speed.static(40.percent)
                it.brightness.fade(25.percent, 2.seconds)
            }
        }
    }

    lightStep(StepCue.Custom("Lucy schreit")) {
        FrontLights.all { it.brightness.fade(100.percent, 5.seconds) }

        Tops.both {
            it.pan.static(it.pan.getCurrentValue())
            it.tilt.static(it.pan.getCurrentValue())
            it.colorWheelMode.static(FuturelightDmh160.ColorWheelMode.White)
            it.prismMode.static(FuturelightDmh160.PrismMode.FROST)
            it.brightness.off(20.seconds)
        }

        backlightBar.color.fade(Color.WARM_WHITE, 0.5.seconds)
        backlightBar.brightness.pulseOnce(2.seconds, 6.seconds)

        BlinderBars.all {
            it.effect.speed.fade(0.percent, 2.seconds)
            it.brightness.pulseOnce(1.seconds, 3.seconds, peak = 50.percent)
        }

        Washs.both { it.brightness.off(0.5.seconds) }
    }

    step(StepCue.MusicEnd) {}
}